﻿/// <summary>
/// Aquesta classe és la que implementa la lògica de negoci, en el nostre cas ja tenim una capa de negoci a la web que consumeix el servei i per tant simplement fa crides a la capa de
/// permanencia de les dades i és cridada per el servei WCF
/// </summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Biblioteca.BibliotecaServiceEntities;
using Biblioteca.BibliotecaServiceDAL;

namespace Biblioteca.BibliotecaServiceLogica
{
    public class BibliotecaLogica
    {
        BibliotecaDAO bibliotecaDAO = new BibliotecaDAO();

        public List<LlibreEntity> GetLlibres(string titolSearch, string descripcioSearch, string AutorId, string EditorialId, string CategoriaId, string TipusLlibreId)
        {
            return bibliotecaDAO.GetLlibres(titolSearch, descripcioSearch, AutorId, EditorialId, CategoriaId, TipusLlibreId);
        }

        public List<PrestecEntity> GetPrestecs(int userId)
        {
            return bibliotecaDAO.GetPrestecs(userId);
        }

        public List<PrestecEntity> GetPrestecsByUsuariId(int usuariId)
        {
            return bibliotecaDAO.GetPrestecsByUsuariId(usuariId);
        }

        public LlibreEntity GetLlibre(int llibreId)
        {
            return bibliotecaDAO.GetLlibre(llibreId);
        }

        public UsuariEntity GetUsuari(int useriId)
        {
            return bibliotecaDAO.GetUsuari(useriId);
        }

        public UsuariEntity GetUsuaribyUsuariId(int usuariId)
        {
            return bibliotecaDAO.GetUsuaribyUsuariID(usuariId);
        }

        public List<AutorEntity> GetAutors()
        {
            return bibliotecaDAO.GetAutors();
        }

        public List<EditorialEntity> GetEditorials()
        {
            return bibliotecaDAO.GetEditorials();
        }

        public ConfiguracioEntity GetConfiguracio()
        {
            return bibliotecaDAO.GetConfiguracio();
        }

        public List<CategoriaEntity> GetCategories()
        {
            return bibliotecaDAO.GetCategories();
        }

        public List<TipusLlibreEntity> GetTipusLlibre()
        {
            return bibliotecaDAO.GetTipusLlibres();
        }

        public string UpdateUsuari(UsuariEntity usuariEnt)
        {
            string result = String.Empty;
            try
            {
                result = bibliotecaDAO.UpdateUsuari(usuariEnt);
                return ("");
            }
            catch (Exception ex)
            {
                return ("Error actualitzant detalls");
            }
        }

        public int Login(string usuari, string password)
        {
            return bibliotecaDAO.login(usuari, password);
        }
    }
}
