﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Net.Mail;

namespace Notificacions
{
    public partial class ServeiPostalNotificacions : ServiceBase
    {

        private System.Timers.Timer timer;

        protected override void OnStart(string[] args)
        {
            eventLog1.WriteEntry("Servei de notificacions encés", EventLogEntryType.Information);
            this.timer = new System.Timers.Timer(86400000); //(86400000);  // 30000 milliseconds = 30 seconds
            this.timer.AutoReset = true;
            this.timer.Elapsed += new System.Timers.ElapsedEventHandler(this.timer_Elapsed);
            this.timer.Start();
        }

        protected override void OnStop()
        {
            eventLog1.WriteEntry("Servei de notificacions parat", EventLogEntryType.Information);
            this.timer.Stop();
            this.timer = null;
        }

        private void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            eventLog1.WriteEntry("Tick");
            NotificacionsEntity notificacions = new NotificacionsEntity();
            var llistaNotificacions = from Ll in notificacions.View_Alertes_Devolucions select Ll;
            bool result = false;
            List<String> resultats = new List<String>();
            Configuracio configuracio = notificacions.Configuracios.Single(c => c.ConfiguracioId == 1);
            string linia = String.Empty;
            foreach (View_Alertes_Devolucions Ll in llistaNotificacions)
            {
                linia = "Enviada notificació per: " + Ll.Nom + " " + Ll.Cognom + " " + Ll.Cognom2 + " --> " + Ll.Titol + " " + Ll.dataEstimada.ToShortDateString();
                result = EnviarNotificacio(Ll.Titol, Ll.Nom + " " + Ll.Cognom + " " + Ll.Cognom2, Ll.dataEstimada.ToShortDateString(), Ll.Email, configuracio.Emailnotificacions, configuracio.ServidorSMTP, configuracio.UsuariSMTP, configuracio.PasswordSMTP, (int)configuracio.PortSMTP);
                if (result)
                {
                    linia = "Enviament correcte: " + linia;
                    eventLog1.WriteEntry(linia, EventLogEntryType.Information);
                }
                else
                {
                    linia = "Error d'enviament: " + linia;
                    eventLog1.WriteEntry(linia, EventLogEntryType.Error);
                }
                resultats.Add(linia);
            }
            result = EnviarNotificacioAdmin(resultats, configuracio.Emailnotificacions, configuracio.ServidorSMTP, configuracio.UsuariSMTP, configuracio.PasswordSMTP, (int)configuracio.PortSMTP);
            if (result)
            {
                eventLog1.WriteEntry("Informe de notificacions de prestecs correcte", EventLogEntryType.Information);
            }
            else
            {
                eventLog1.WriteEntry("Error a l'enviar el informe de notificacions de prestecs", EventLogEntryType.Error);
            }
            notificacions.Dispose();
        }

        public ServeiPostalNotificacions()
        {
            InitializeComponent();
            this.ServiceName = "NotificacionsBiblioteca";
            InitializeComponent();
            if (!System.Diagnostics.EventLog.SourceExists("BibliotecaNotificacions"))
            {
                System.Diagnostics.EventLog.CreateEventSource(
                    "BibliotecaNotificacions", "Biblioteca");
            }
            eventLog1.Source = "BibliotecaNotificacions";
            eventLog1.Log = "Biblioteca";
        }

        // service entry point
       /* static void Main()
        {
            System.ServiceProcess.ServiceBase.Run(new ServeiPostalNotificacions());
        }*/

        private bool EnviarNotificacio(string llibre, string nomComplet, string dataRetorn, string desti, string origen, string smtpServer, string smtpUser, string smtpPassword, int smtpPort)
        {

            MailMessage email = new MailMessage();
            email.To.Add(new MailAddress(desti));
            email.From = new MailAddress(origen);
            email.Subject = "Alerta de préstecs per " + nomComplet;
            email.Body = "Nom: " + nomComplet + "<br/>Email: " + desti + "<br/> Llibre: " + llibre + " <br/> Data de devolució: " + dataRetorn;
            email.IsBodyHtml = true;
            email.Priority = MailPriority.Normal;

            SmtpClient smtp = new SmtpClient();
            smtp.Host = smtpServer;
            smtp.Port = smtpPort;
            smtp.EnableSsl = false;
            smtp.UseDefaultCredentials = false;
            smtp.Credentials = new System.Net.NetworkCredential(smtpUser, smtpPassword);
            //smtp.Credentials = new System.Net.NetworkCredential("adgarett", "letmein");
            try
            {
                smtp.Send(email);
                email.Dispose();
                return true;
            }
            catch
            {
                return false;
            }
        }

        private bool EnviarNotificacioAdmin(List<string> resultats, string origen, string smtpServer, string smtpUser, string smtpPassword, int smtpPort)
        {
            MailMessage email = new MailMessage();
            email.To.Add(new MailAddress(origen));
            email.From = new MailAddress(origen);
            email.Subject = "Informe d'enviament d'alertes de préstec " + DateTime.Now.ToString();
            string body = String.Empty;
            foreach (String s in resultats)
            {
                body = body + s + "<br/>";
            }
            email.Body = body;
            email.IsBodyHtml = true;
            email.Priority = MailPriority.Normal;

            SmtpClient smtp = new SmtpClient();
            smtp.Host = smtpServer;
            smtp.Port = smtpPort;
            smtp.EnableSsl = false;
            smtp.UseDefaultCredentials = false;
            smtp.Credentials = new System.Net.NetworkCredential(smtpUser, smtpPassword);
            //smtp.Credentials = new System.Net.NetworkCredential("adgarett", "letmein");
            try
            {
                smtp.Send(email);
                email.Dispose();
                return true;
            }
            catch
            {
                return false;
            }
        }

    }
}
