﻿/// <summary>
/// Aquesta és la classe responsable de controlar els Tipus de llibre i les pàgines (vistes) que se'n deriven
/// </summary>
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebAdmin.Models;

namespace WebAdmin.Controllers
{
    public class TipusLlibreController : Controller
    {
        private BibliotecaEntities1 db = new BibliotecaEntities1();

        //
        // GET: /TipusLlibre/

        public ActionResult Index()
        {
            return View(db.TipusLlibres.ToList());
        }

        //
        // GET: /TipusLlibre/Details/5

        public ActionResult Details(int id = 0)
        {
            TipusLlibre tipusllibre = db.TipusLlibres.Single(t => t.TipusLlibreId == id);
            if (tipusllibre == null)
            {
                return HttpNotFound();
            }
            return View(tipusllibre);
        }

        //
        // GET: /TipusLlibre/Create

        public ActionResult Create()
        {
            return View();
        }

        //
        // POST: /TipusLlibre/Create

        [HttpPost]
        public ActionResult Create(TipusLlibre tipusllibre)
        {
            if (ModelState.IsValid)
            {
                db.TipusLlibres.AddObject(tipusllibre);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            return View(tipusllibre);
        }

        //
        // GET: /TipusLlibre/Edit/5

        public ActionResult Edit(int id = 0)
        {
            TipusLlibre tipusllibre = db.TipusLlibres.Single(t => t.TipusLlibreId == id);
            if (tipusllibre == null)
            {
                return HttpNotFound();
            }
            return View(tipusllibre);
        }

        //
        // POST: /TipusLlibre/Edit/5

        [HttpPost]
        public ActionResult Edit(TipusLlibre tipusllibre)
        {
            if (ModelState.IsValid)
            {
                db.TipusLlibres.Attach(tipusllibre);
                db.ObjectStateManager.ChangeObjectState(tipusllibre, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(tipusllibre);
        }

        //
        // GET: /TipusLlibre/Delete/5

        public ActionResult Delete(int id = 0)
        {
            var llibres = from p in db.Llibres
                          select p;

            llibres = llibres.Where(p => p.TipusLlibreId == id);
            if (llibres.Count() != 0)
            {
                List<String> ErrorList = new List<String>();
                ErrorList.Add("Existeixen Llibres del tipus a eliminar, siusplau elimina els llibres o canvia'n el tipus abans de procedir a l'eliminació del mateix");
                foreach (var p in llibres.ToList())
                {
                    ErrorList.Add("   - LlibreId: " + p.LlibreId.ToString() + " " + p.Titol + " " + p.ISBN.ToString());
                }
                ViewBag.errorList = ErrorList;
                ViewBag.errorTitle = "Error Eliminant el tipus de llibre";
                ViewBag.Referrer = Request.UrlReferrer.LocalPath;
                return View("../Error/Error");
            }
            TipusLlibre tipusllibre = db.TipusLlibres.Single(t => t.TipusLlibreId == id);
            if (tipusllibre == null)
            {
                return HttpNotFound();
            }
            return View(tipusllibre);
        }

        //
        // POST: /TipusLlibre/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            TipusLlibre tipusllibre = db.TipusLlibres.Single(t => t.TipusLlibreId == id);
            db.TipusLlibres.DeleteObject(tipusllibre);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}