﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebExterna.Filters;
using System.Net.Mail;
using WebExterna.Models;

namespace WebExterna.Controllers
{
    [InitializeSimpleMembership]
    public class HomeController : Controller
    {
        BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();

        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to jump-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }


        /// <summary>
        /// GET: /ContactUs/
        /// Mostrem un formulari de contacte
        /// </summary>
        [HttpGet]
        public ViewResult Contact()
        {
            return View();
        }

        /// <summary>
        /// POST: /Home/Contact
        /// Recollim el formulari de contacte, el verifique i enviem l'email
        /// </summary>
        /// <parm name="usuariContacte">dades del formulari de contacte via el model ContactModel</param>
         [HttpPost]
         public ViewResult Contact(ContactaModel usuariContacte)
         {
             if (ModelState.IsValid)
             {
                 bool emailResult;
                 emailResult = EnviarEmailContacte(usuariContacte.Telefon, usuariContacte.Nom + " " + usuariContacte.Cognoms , usuariContacte.Email, usuariContacte.Missatge);
                if (!emailResult)
                {
                    List<String> ErrorList = new List<String>();
                    ErrorList.Add("No S'ha pogut enviar el missatge");
                    ViewBag.errorList = ErrorList;
                    ViewBag.errorTitle = "En aquest moment no hem pogut enviar el missatege, verifiqui la seva adreça de correui torna a intentar-ho en una estona, disculpa les molesties";
                    ViewBag.Referrer = Request.UrlReferrer.LocalPath;
                    return View("../Error/Error");
                }
                ViewBag.Missatge = "Missatge enviat correctament, gracies per posar-te en contacte amb nosaltres, ben aviat rebras la nostra resposta";
                ViewBag.Referrer = Request.UrlReferrer.LocalPath;
                 return View("../Error/Gracies");
             }
             else
             {
                 return View();
             }
         }

         /// <summary>
         /// Enviem el formulari de contacte
         /// </summary>
         /// <parm name="tfn">Telefon de la persona que vol contactar</param>
         /// <parm name="nomComplet">Nom i cognom de la persona que vol contactar</param>
         /// <parm name="emailIn">Email de la persona que vol contactar</param>
         /// <parm name="missatge">Missatge</param>
        private bool EnviarEmailContacte(string tfn, string nomComplet, string emailIn, string missatge)
         {

             BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();
             WebExterna.BibliotecaServiceWebExterna.Configuracio configuracio = new WebExterna.BibliotecaServiceWebExterna.Configuracio();
             configuracio = obj.GetConfiguracio();
             MailMessage email = new MailMessage();
             email.To.Add(new MailAddress(configuracio.Emailnotificacions));
             email.From = new MailAddress(configuracio.Emailnotificacions);
             email.Subject = "Formulari de contacte web " + nomComplet;
             email.Body = "Nom: " + nomComplet + "<br/>Email: " + emailIn + "<br/> Telefon:" + tfn + " <br/>" + missatge;
             email.IsBodyHtml = true;
             email.Priority = MailPriority.Normal;

             SmtpClient smtp = new SmtpClient();
             smtp.Host = configuracio.ServidorSMTP;
             //smtp.Host = "outbound.mailhop.org";
             //smtp.Port = 25;
             smtp.Port = configuracio.PortSMTP;
             smtp.EnableSsl = false;
             smtp.UseDefaultCredentials = false;
             smtp.Credentials = new System.Net.NetworkCredential(configuracio.UsuariSMTP, configuracio.PasswordSMTP);
             //smtp.Credentials = new System.Net.NetworkCredential("adgarett", "letmein");
             try
             {
                 smtp.Send(email);
                 email.Dispose();
                 return true;
             }
             catch
             {
                 return false;
             }
         }
    }
}