﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebMatrix.WebData;
using WebExterna.Filters;

namespace WebExterna.Controllers
{
    [InitializeSimpleMembership]
    public class UsuariController : Controller
    {

        /// <summary>
        /// GET: /Prestecs de l'usuari/
        /// Mostrem un llistat de prestecs per l'usuari autentificat
        /// </summary>
        public ActionResult prestec()
        {
            int usuariActual = (int)WebSecurity.CurrentUserId;
            BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();

            List<WebExterna.BibliotecaServiceWebExterna.Prestec> elsPrestecs = new List<WebExterna.BibliotecaServiceWebExterna.Prestec>();
            WebExterna.BibliotecaServiceWebExterna.Prestec[] array;
            array = obj.GetPrestecs(usuariActual);
            foreach (WebExterna.BibliotecaServiceWebExterna.Prestec prestecActual in array)
                elsPrestecs.Add(prestecActual);

            int total = elsPrestecs.Count();
            if (total == 0)
                ViewBag.IsEmpty = true;
            else
                ViewBag.IsEmpty = false;
            //llibres = llibres.OrderBy(l => l.Autor.NomAutor);
            return View(elsPrestecs);
        }


        /// <summary>
        /// GET: /Prestecs de l'usuari/
        /// Mostrem els detall de l'usuari autentificat
        /// </summary>
        public ActionResult Details()
        {
            int usuariActual = (int)WebSecurity.CurrentUserId;
            BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();
            WebExterna.BibliotecaServiceWebExterna.Usuari usuari = new WebExterna.BibliotecaServiceWebExterna.Usuari();
            usuari = obj.GetUsuari(usuariActual);
            return View(usuari);
        }

        /// <summary>
        /// GET: /Usuari/Edit/
        /// Mostrem l'informació de l'usuari autentificat
        /// </summary>
        /// <parm name="id">Identificador de l'usuari, no s'utilitza</param>
        public ActionResult Edit(int id = 0)
        {
            int usuariActual = (int)WebSecurity.CurrentUserId;
            BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();
            Models.LocalUsuariModel usuModel = new Models.LocalUsuariModel();
            WebExterna.BibliotecaServiceWebExterna.Usuari usuari = new WebExterna.BibliotecaServiceWebExterna.Usuari();
            usuari = obj.GetUsuari(usuariActual);
            if (usuari == null)
            {
                return HttpNotFound();
            }
            usuModel.Nom = usuari.Nom;
            usuModel.UsuariId = usuari.UsuariId;
            usuModel.Cognom = usuari.Cognom;
            usuModel.Cognom2 = usuari.Cognom2;
            usuModel.DNI = usuari.DNI;
            usuModel.Poblacio = usuari.Poblacio;
            usuModel.Direccio = usuari.Direccio;
            usuModel.CodiPostal = usuari.CodiPostal;
            usuModel.Email = usuari.Email;
            usuModel.Notificacions = usuari.Notificacions;
            usuModel.AccesWeb = usuari.AccesWeb;
            return View(usuModel);
        }


        /// <summary>
        /// POST: /Usuari/Edit/5
        /// Actualitzem les dades de l'usuari
        /// </summary>
        /// <parm name="usuari">L'usuari via LocalUsuariModel</param>
        [HttpPost]
        public ActionResult Edit(Models.LocalUsuariModel usuari)
        {
            if (ModelState.IsValid)
            {
                BibliotecaServiceWebExterna.BibliotecaServiceClient obj = new BibliotecaServiceWebExterna.BibliotecaServiceClient();
                WebExterna.BibliotecaServiceWebExterna.Usuari usuModel = new WebExterna.BibliotecaServiceWebExterna.Usuari();
                string result = String.Empty;
                usuModel.Nom = usuari.Nom;
                usuModel.UsuariId = usuari.UsuariId;
                usuModel.Cognom = usuari.Cognom;
                usuModel.Cognom2 = usuari.Cognom2;
                usuModel.DNI = usuari.DNI;
                usuModel.Poblacio = usuari.Poblacio;
                usuModel.Direccio = usuari.Direccio;
                usuModel.CodiPostal = usuari.CodiPostal;
                usuModel.Email = usuari.Email;
                usuModel.Notificacions = usuari.Notificacions;
                usuModel.AccesWeb = usuari.AccesWeb;
                result = obj.UpdateUsuari(usuModel);
                if (result.Equals(String.Empty))
                {
                    ViewBag.Resultat = "Les dades d'usuari s'han actualitzat correctament";
                    return View();
                }
                else
                {
                    List<String> ErrorList = new List<String>();
                    ErrorList.Add(result);
                    ViewBag.errorList = ErrorList;
                    ViewBag.errorTitle = "Error Actualitzant l'usuari";
                    ViewBag.Referrer = Request.UrlReferrer.LocalPath;
                    return View("../Error/Error");
                }
            }
            return View(usuari);
        }
    }
}
