﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace WebExterna.Models
{
    public class ContactaModel
    {
        [Required(ErrorMessage = "Nom és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Nom { get; set; }

        [Required(ErrorMessage = "Cognom és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Cognoms { get; set; }

        [Required(ErrorMessage = "Codi Postal és un camp obligatori")]
        public string Telefon { get; set; }

        [Required(ErrorMessage = "Email és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        [RegularExpression(@"^([\w\.\-]+)@([\w\-]+)((\.(\w){2,3})+)$", ErrorMessage = "Adreça d'email incorrecta")]
        public string Email { get; set; }

        [Required(ErrorMessage = "Omple el camp de si ets usuari de la biblioteca")]
        public bool usuariDeLaBiblio { get; set; }

        [Required(ErrorMessage = "El missatge és un camp obligatori")]
        [StringLength(2000, ErrorMessage = "La longitud màxima és de 2000 caràcters")]
        public string Missatge { get; set; }
    }
}