﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace WebExterna.Models
{
    public class LocalUsuariModel
    {
        [Key]
        [Required]
        public int UsuariId { get; set; }

        [Required(ErrorMessage = "Nom és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Nom { get; set; }
 

        [Required(ErrorMessage="Nom és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Cognom { get; set; }

        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Cognom2 { get; set; }

        [Required(ErrorMessage = "DNI és un camp obligatori")]
        [RegularExpression(@"^(([A-Z]\d{8})|(\d{8}[A-Z]))$", ErrorMessage= "Format de DNI incorrecte")]
        public string DNI { get; set; }

        [Required(ErrorMessage = "Direcció és un camp obligatori")]
        [StringLength(100, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Direccio { get; set; }

        [Required(ErrorMessage = "Població és un camp obligatori")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Poblacio { get; set; }

        [Required(ErrorMessage = "Codi Postal és un camp obligatori")]
        [RegularExpression(@"(0[1-9]|5[0-2]|[0-4][0-9])[0-9]{3}", ErrorMessage = "Codi Postal incorrecte")]
        public string CodiPostal { get; set; }

        [Required(ErrorMessage = "Email és un camp obligatori")]
        [RegularExpression(@"^([\w\.\-]+)@([\w\-]+)((\.(\w){2,3})+)$", ErrorMessage= "Adreça d'email incorrecta")]
        [StringLength(50, ErrorMessage = "La longitud màxima és de 50 caràcters")]
        public string Email { get; set; }

        public bool Notificacions { get; set; }

        public bool AccesWeb { get; set; }
    }
}