﻿/* =========================================================
 * bootstrap-datepicker.js
 * http://www.eyecon.ro/bootstrap-datepicker
 * =========================================================
 * Copyright 2012 Stefan Petre
 * Improvements by Andrew Rowls
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================================================= */
!function(n){function u(){return new Date(Date.UTC.apply(Date,arguments))}var r=function(r,u){var f=this;this.element=n(r),this.language=u.language||this.element.data("date-language")||"en",this.language=this.language in i?this.language:this.language.split("-")[0],this.language=this.language in i?this.language:"en",this.isRTL=i[this.language].rtl||!1,this.format=t.parseFormat(u.format||this.element.data("date-format")||i[this.language].format||"mm/dd/yyyy"),this.isInline=!1,this.isInput=this.element.is("input"),this.component=this.element.is(".date")?this.element.find(".add-on"):!1,this.hasInput=this.component&&this.element.find("input").length,this.component&&this.component.length===0&&(this.component=!1),this._attachEvents(),this.forceParse=!0,"forceParse"in u?this.forceParse=u.forceParse:"dateForceParse"in this.element.data()&&(this.forceParse=this.element.data("date-force-parse")),this.picker=n(t.template).appendTo(this.isInline?this.element:"body").on({click:n.proxy(this.click,this),mousedown:n.proxy(this.mousedown,this)}),this.isInline?this.picker.addClass("datepicker-inline"):this.picker.addClass("datepicker-dropdown dropdown-menu"),this.isRTL&&(this.picker.addClass("datepicker-rtl"),this.picker.find(".prev i, .next i").toggleClass("icon-arrow-left icon-arrow-right"));n(document).on("mousedown",function(t){n(t.target).closest(".datepicker.datepicker-inline, .datepicker.datepicker-dropdown").length===0&&f.hide()});this.autoclose=!1,"autoclose"in u?this.autoclose=u.autoclose:"dateAutoclose"in this.element.data()&&(this.autoclose=this.element.data("date-autoclose")),this.keyboardNavigation=!0,"keyboardNavigation"in u?this.keyboardNavigation=u.keyboardNavigation:"dateKeyboardNavigation"in this.element.data()&&(this.keyboardNavigation=this.element.data("date-keyboard-navigation")),this.viewMode=this.startViewMode=0;switch(u.startView||this.element.data("date-start-view")){case 2:case"decade":this.viewMode=this.startViewMode=2;break;case 1:case"year":this.viewMode=this.startViewMode=1}this.todayBtn=u.todayBtn||this.element.data("date-today-btn")||!1,this.todayHighlight=u.todayHighlight||this.element.data("date-today-highlight")||!1,this.calendarWeeks=!1,"calendarWeeks"in u?this.calendarWeeks=u.calendarWeeks:"dateCalendarWeeks"in this.element.data()&&(this.calendarWeeks=this.element.data("date-calendar-weeks")),this.calendarWeeks&&this.picker.find("tfoot th.today").attr("colspan",function(n,t){return parseInt(t)+1}),this.weekStart=(u.weekStart||this.element.data("date-weekstart")||i[this.language].weekStart||0)%7,this.weekEnd=(this.weekStart+6)%7,this.startDate=-Infinity,this.endDate=Infinity,this.daysOfWeekDisabled=[],this.setStartDate(u.startDate||this.element.data("date-startdate")),this.setEndDate(u.endDate||this.element.data("date-enddate")),this.setDaysOfWeekDisabled(u.daysOfWeekDisabled||this.element.data("date-days-of-week-disabled")),this.fillDow(),this.fillMonths(),this.update(),this.showMode(),this.isInline&&this.show()},i,t;r.prototype={constructor:r,_events:[],_attachEvents:function(){this._detachEvents(),this.isInput?this._events=[[this.element,{focus:n.proxy(this.show,this),keyup:n.proxy(this.update,this),keydown:n.proxy(this.keydown,this)}]]:this.component&&this.hasInput?this._events=[[this.element.find("input"),{focus:n.proxy(this.show,this),keyup:n.proxy(this.update,this),keydown:n.proxy(this.keydown,this)}],[this.component,{click:n.proxy(this.show,this)}]]:this.element.is("div")?this.isInline=!0:this._events=[[this.element,{click:n.proxy(this.show,this)}]];for(var t=0,i,r;t<this._events.length;t++){i=this._events[t][0],r=this._events[t][1];i.on(r)}},_detachEvents:function(){for(var n=0,t,i;n<this._events.length;n++)t=this._events[n][0],i=this._events[n][1],t.off(i);this._events=[]},show:function(t){this.picker.show(),this.height=this.component?this.component.outerHeight():this.element.outerHeight(),this.update(),this.place();n(window).on("resize",n.proxy(this.place,this));t&&(t.stopPropagation(),t.preventDefault()),this.element.trigger({type:"show",date:this.date})},hide:function(){this.isInline||this.picker.is(":visible")&&(this.picker.hide(),n(window).off("resize",this.place),this.viewMode=this.startViewMode,this.showMode(),this.isInput||n(document).off("mousedown",this.hide),this.forceParse&&(this.isInput&&this.element.val()||this.hasInput&&this.element.find("input").val())&&this.setValue(),this.element.trigger({type:"hide",date:this.date}))},remove:function(){this._detachEvents(),this.picker.remove(),delete this.element.data().datepicker},getDate:function(){var n=this.getUTCDate();return new Date(n.getTime()+n.getTimezoneOffset()*6e4)},getUTCDate:function(){return this.date},setDate:function(n){this.setUTCDate(new Date(n.getTime()-n.getTimezoneOffset()*6e4))},setUTCDate:function(n){this.date=n,this.setValue()},setValue:function(){var n=this.getFormattedDate();this.isInput?this.element.val(n):(this.component&&this.element.find("input").val(n),this.element.data("date",n))},getFormattedDate:function(n){return n===undefined&&(n=this.format),t.formatDate(this.date,n,this.language)},setStartDate:function(n){this.startDate=n||-Infinity,this.startDate!==-Infinity&&(this.startDate=t.parseDate(this.startDate,this.format,this.language)),this.update(),this.updateNavArrows()},setEndDate:function(n){this.endDate=n||Infinity,this.endDate!==Infinity&&(this.endDate=t.parseDate(this.endDate,this.format,this.language)),this.update(),this.updateNavArrows()},setDaysOfWeekDisabled:function(t){this.daysOfWeekDisabled=t||[],n.isArray(this.daysOfWeekDisabled)||(this.daysOfWeekDisabled=this.daysOfWeekDisabled.split(/,\s*/)),this.daysOfWeekDisabled=n.map(this.daysOfWeekDisabled,function(n){return parseInt(n,10)}),this.update(),this.updateNavArrows()},place:function(){if(!this.isInline){var i=parseInt(this.element.parents().filter(function(){return n(this).css("z-index")!="auto"}).first().css("z-index"))+10,t=this.component?this.component.offset():this.element.offset(),r=this.component?this.component.outerHeight(!0):this.element.outerHeight(!0);this.picker.css({top:t.top+r,left:t.left,zIndex:i})}},update:function(){var n,i=!1;arguments&&arguments.length&&(typeof arguments[0]=="string"||arguments[0]instanceof Date)?(n=arguments[0],i=!0):n=this.isInput?this.element.val():this.element.data("date")||this.element.find("input").val(),this.date=t.parseDate(n,this.format,this.language),i&&this.setValue(),this.viewDate=this.date<this.startDate?new Date(this.startDate):this.date>this.endDate?new Date(this.endDate):new Date(this.date),this.fill()},fillDow:function(){var r=this.weekStart,n="<tr>",t;for(this.calendarWeeks&&(t='<th class="cw">&nbsp;<\/th>',n+=t,this.picker.find(".datepicker-days thead tr:first-child").prepend(t));r<this.weekStart+7;)n+='<th class="dow">'+i[this.language].daysMin[r++%7]+"<\/th>";n+="<\/tr>",this.picker.find(".datepicker-days thead").append(n)},fillMonths:function(){for(var n="",t=0;t<12;)n+='<span class="month">'+i[this.language].monthsShort[t++]+"<\/span>";this.picker.find(".datepicker-months td").html(n)},fill:function(){var k=new Date(this.viewDate),f=k.getUTCFullYear(),l=k.getUTCMonth(),v=this.startDate!==-Infinity?this.startDate.getUTCFullYear():-Infinity,it=this.startDate!==-Infinity?this.startDate.getUTCMonth():-Infinity,y=this.endDate!==Infinity?this.endDate.getUTCFullYear():Infinity,rt=this.endDate!==Infinity?this.endDate.getUTCMonth():Infinity,d=this.date&&this.date.valueOf(),p=new Date,r,w,s,e,o,a,h,tt,c;for(this.picker.find(".datepicker-days thead th.switch").text(i[this.language].months[l]+" "+f),this.picker.find("tfoot th.today").text(i[this.language].today).toggle(this.todayBtn!==!1),this.updateNavArrows(),this.fillMonths(),r=u(f,l-1,28,0,0,0,0),w=t.getDaysInMonth(r.getUTCFullYear(),r.getUTCMonth()),r.setUTCDate(w),r.setUTCDate(w-(r.getUTCDay()-this.weekStart+7)%7),s=new Date(r),s.setUTCDate(s.getUTCDate()+42),s=s.valueOf(),e=[];r.valueOf()<s;){if(r.getUTCDay()==this.weekStart&&(e.push("<tr>"),this.calendarWeeks)){var g=new Date(+r+(this.weekStart-r.getUTCDay()-7)%7*864e5),nt=new Date(+g+(11-g.getUTCDay())%7*864e5),b=new Date(+(b=u(nt.getUTCFullYear(),0,1))+(11-b.getUTCDay())%7*864e5),ut=(nt-b)/6048e5+1;e.push('<td class="cw">'+ut+"<\/td>")}o="",r.getUTCFullYear()<f||r.getUTCFullYear()==f&&r.getUTCMonth()<l?o+=" old":(r.getUTCFullYear()>f||r.getUTCFullYear()==f&&r.getUTCMonth()>l)&&(o+=" new"),this.todayHighlight&&r.getUTCFullYear()==p.getFullYear()&&r.getUTCMonth()==p.getMonth()&&r.getUTCDate()==p.getDate()&&(o+=" today"),d&&r.valueOf()==d&&(o+=" active"),(r.valueOf()<this.startDate||r.valueOf()>this.endDate||n.inArray(r.getUTCDay(),this.daysOfWeekDisabled)!==-1)&&(o+=" disabled"),e.push('<td class="day'+o+'">'+r.getUTCDate()+"<\/td>"),r.getUTCDay()==this.weekEnd&&e.push("<\/tr>"),r.setUTCDate(r.getUTCDate()+1)}for(this.picker.find(".datepicker-days tbody").empty().append(e.join("")),a=this.date&&this.date.getUTCFullYear(),h=this.picker.find(".datepicker-months").find("th:eq(1)").text(f).end().find("span").removeClass("active"),a&&a==f&&h.eq(this.date.getUTCMonth()).addClass("active"),(f<v||f>y)&&h.addClass("disabled"),f==v&&h.slice(0,it).addClass("disabled"),f==y&&h.slice(rt+1).addClass("disabled"),e="",f=parseInt(f/10,10)*10,tt=this.picker.find(".datepicker-years").find("th:eq(1)").text(f+"-"+(f+9)).end().find("td"),f-=1,c=-1;c<11;c++)e+='<span class="year'+(c==-1||c==10?" old":"")+(a==f?" active":"")+(f<v||f>y?" disabled":"")+'">'+f+"<\/span>",f+=1;tt.html(e)},updateNavArrows:function(){var t=new Date(this.viewDate),n=t.getUTCFullYear(),i=t.getUTCMonth();switch(this.viewMode){case 0:this.startDate!==-Infinity&&n<=this.startDate.getUTCFullYear()&&i<=this.startDate.getUTCMonth()?this.picker.find(".prev").css({visibility:"hidden"}):this.picker.find(".prev").css({visibility:"visible"}),this.endDate!==Infinity&&n>=this.endDate.getUTCFullYear()&&i>=this.endDate.getUTCMonth()?this.picker.find(".next").css({visibility:"hidden"}):this.picker.find(".next").css({visibility:"visible"});break;case 1:case 2:this.startDate!==-Infinity&&n<=this.startDate.getUTCFullYear()?this.picker.find(".prev").css({visibility:"hidden"}):this.picker.find(".prev").css({visibility:"visible"}),this.endDate!==Infinity&&n>=this.endDate.getUTCFullYear()?this.picker.find(".next").css({visibility:"hidden"}):this.picker.find(".next").css({visibility:"visible"})}},click:function(i){var r,s,e,h,f,o;if(i.stopPropagation(),i.preventDefault(),r=n(i.target).closest("span, td, th"),r.length==1)switch(r[0].nodeName.toLowerCase()){case"th":switch(r[0].className){case"switch":this.showMode(1);break;case"prev":case"next":s=t.modes[this.viewMode].navStep*(r[0].className=="prev"?-1:1);switch(this.viewMode){case 0:this.viewDate=this.moveMonth(this.viewDate,s);break;case 1:case 2:this.viewDate=this.moveYear(this.viewDate,s)}this.fill();break;case"today":e=new Date,e=u(e.getFullYear(),e.getMonth(),e.getDate(),0,0,0),this.showMode(-2),h=this.todayBtn=="linked"?null:"view",this._setDate(e,h)}break;case"span":r.is(".disabled")||(this.viewDate.setUTCDate(1),r.is(".month")?(f=r.parent().find("span").index(r),this.viewDate.setUTCMonth(f),this.element.trigger({type:"changeMonth",date:this.viewDate})):(o=parseInt(r.text(),10)||0,this.viewDate.setUTCFullYear(o),this.element.trigger({type:"changeYear",date:this.viewDate})),this.showMode(-1),this.fill());break;case"td":if(r.is(".day")&&!r.is(".disabled")){var c=parseInt(r.text(),10)||1,o=this.viewDate.getUTCFullYear(),f=this.viewDate.getUTCMonth();r.is(".old")?f===0?(f=11,o-=1):f-=1:r.is(".new")&&(f==11?(f=0,o+=1):f+=1),this._setDate(u(o,f,c,0,0,0,0))}}},_setDate:function(n,t){t&&t!="date"||(this.date=n),t&&t!="view"||(this.viewDate=n),this.fill(),this.setValue(),this.element.trigger({type:"changeDate",date:this.date});var i;this.isInput?i=this.element:this.component&&(i=this.element.find("input")),i&&(i.change(),this.autoclose&&(!t||t=="date")&&this.hide())},moveMonth:function(n,t){var f;if(!t)return n;var i=new Date(n.valueOf()),e=i.getUTCDate(),o=i.getUTCMonth(),s=Math.abs(t),r,u;if(t=t>0?1:-1,s==1)u=t==-1?function(){return i.getUTCMonth()==o}:function(){return i.getUTCMonth()!=r},r=o+t,i.setUTCMonth(r),(r<0||r>11)&&(r=(r+12)%12);else{for(f=0;f<s;f++)i=this.moveMonth(i,t);r=i.getUTCMonth(),i.setUTCDate(e),u=function(){return r!=i.getUTCMonth()}}while(u())i.setUTCDate(--e),i.setUTCMonth(r);return i},moveYear:function(n,t){return this.moveMonth(n,t*12)},dateWithinRange:function(n){return n>=this.startDate&&n<=this.endDate},keydown:function(n){var u,t,i,r,f;if(this.picker.is(":not(:visible)")){n.keyCode==27&&this.show();return}u=!1;switch(n.keyCode){case 27:this.hide(),n.preventDefault();break;case 37:case 39:if(!this.keyboardNavigation)break;t=n.keyCode==37?-1:1,n.ctrlKey?(i=this.moveYear(this.date,t),r=this.moveYear(this.viewDate,t)):n.shiftKey?(i=this.moveMonth(this.date,t),r=this.moveMonth(this.viewDate,t)):(i=new Date(this.date),i.setUTCDate(this.date.getUTCDate()+t),r=new Date(this.viewDate),r.setUTCDate(this.viewDate.getUTCDate()+t)),this.dateWithinRange(i)&&(this.date=i,this.viewDate=r,this.setValue(),this.update(),n.preventDefault(),u=!0);break;case 38:case 40:if(!this.keyboardNavigation)break;t=n.keyCode==38?-1:1,n.ctrlKey?(i=this.moveYear(this.date,t),r=this.moveYear(this.viewDate,t)):n.shiftKey?(i=this.moveMonth(this.date,t),r=this.moveMonth(this.viewDate,t)):(i=new Date(this.date),i.setUTCDate(this.date.getUTCDate()+t*7),r=new Date(this.viewDate),r.setUTCDate(this.viewDate.getUTCDate()+t*7)),this.dateWithinRange(i)&&(this.date=i,this.viewDate=r,this.setValue(),this.update(),n.preventDefault(),u=!0);break;case 13:this.hide(),n.preventDefault();break;case 9:this.hide()}u&&(this.element.trigger({type:"changeDate",date:this.date}),this.isInput?f=this.element:this.component&&(f=this.element.find("input")),f&&f.change())},showMode:function(n){n&&(this.viewMode=Math.max(0,Math.min(2,this.viewMode+n))),this.picker.find(">div").hide().filter(".datepicker-"+t.modes[this.viewMode].clsName).css("display","block"),this.updateNavArrows()}},n.fn.datepicker=function(t){var i=Array.apply(null,arguments);return i.shift(),this.each(function(){var f=n(this),u=f.data("datepicker"),e=typeof t=="object"&&t;u||f.data("datepicker",u=new r(this,n.extend({},n.fn.datepicker.defaults,e))),typeof t=="string"&&typeof u[t]=="function"&&u[t].apply(u,i)})},n.fn.datepicker.defaults={},n.fn.datepicker.Constructor=r,i=n.fn.datepicker.dates={en:{days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"],daysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sun"],daysMin:["Su","Mo","Tu","We","Th","Fr","Sa","Su"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],today:"Today"}},t={modes:[{clsName:"days",navFnc:"Month",navStep:1},{clsName:"months",navFnc:"FullYear",navStep:1},{clsName:"years",navFnc:"FullYear",navStep:10}],isLeapYear:function(n){return n%4==0&&n%100!=0||n%400==0},getDaysInMonth:function(n,i){return[31,t.isLeapYear(n)?29:28,31,30,31,30,31,31,30,31,30,31][i]},validParts:/dd?|DD?|mm?|MM?|yy(?:yy)?/g,nonpunctuation:/[^ -\/:-@\[\u3400-\u9fff-`{-~\t\n\r]+/g,parseFormat:function(n){var t=n.replace(this.validParts,'\0').split('\0'),i=n.match(this.validParts);if(!t||!t.length||!i||i.length===0)throw new Error("Invalid date format.");return{separators:t,parts:i}},parseDate:function(t,f,e){var k,s,l,a,c,d,o,y;if(t instanceof Date)return t;if(/^[\-+]\d+[dmwy]([\s,]+[\-+]\d+[dmwy])*$/.test(t)){for(k=/([\-+]\d+)([dmwy])/,s=t.match(/([\-+]\d+)([dmwy])/g),t=new Date,o=0;o<s.length;o++){l=k.exec(s[o]),a=parseInt(l[1]);switch(l[2]){case"d":t.setUTCDate(t.getUTCDate()+a);break;case"m":t=r.prototype.moveMonth.call(r.prototype,t,a);break;case"w":t.setUTCDate(t.getUTCDate()+a*7);break;case"y":t=r.prototype.moveYear.call(r.prototype,t,a)}}return u(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate(),0,0,0)}var s=t&&t.match(this.nonpunctuation)||[],t=new Date,p={},b=["yyyy","yy","M","MM","m","mm","d","dd"],h={yyyy:function(n,t){return n.setUTCFullYear(t)},yy:function(n,t){return n.setUTCFullYear(2e3+t)},m:function(n,t){for(t-=1;t<0;)t+=12;for(t%=12,n.setUTCMonth(t);n.getUTCMonth()!=t;)n.setUTCDate(n.getUTCDate()-1);return n},d:function(n,t){return n.setUTCDate(t)}},v,w,l;if(h.M=h.MM=h.mm=h.m,h.dd=h.d,t=u(t.getFullYear(),t.getMonth(),t.getDate(),0,0,0),c=f.parts.slice(),s.length!=c.length&&(c=n(c).filter(function(t,i){return n.inArray(i,b)!==-1}).toArray()),s.length==c.length){for(o=0,d=c.length;o<d;o++){if(v=parseInt(s[o],10),l=c[o],isNaN(v))switch(l){case"MM":w=n(i[e].months).filter(function(){var n=this.slice(0,s[o].length),t=s[o].slice(0,n.length);return n==t}),v=n.inArray(w[0],i[e].months)+1;break;case"M":w=n(i[e].monthsShort).filter(function(){var n=this.slice(0,s[o].length),t=s[o].slice(0,n.length);return n==t}),v=n.inArray(w[0],i[e].monthsShort)+1}p[l]=v}for(o=0;o<b.length;o++)y=b[o],y in p&&!isNaN(p[y])&&h[y](t,p[y])}return t},formatDate:function(t,r,u){var f={d:t.getUTCDate(),D:i[u].daysShort[t.getUTCDay()],DD:i[u].days[t.getUTCDay()],m:t.getUTCMonth()+1,M:i[u].monthsShort[t.getUTCMonth()],MM:i[u].months[t.getUTCMonth()],yy:t.getUTCFullYear().toString().substring(2),yyyy:t.getUTCFullYear()},t,o,e,s;for(f.dd=(f.d<10?"0":"")+f.d,f.mm=(f.m<10?"0":"")+f.m,t=[],o=n.extend([],r.separators),e=0,s=r.parts.length;e<s;e++)o.length&&t.push(o.shift()),t.push(f[r.parts[e]]);return t.join("")},headTemplate:'<thead><tr><th class="prev"><i class="icon-arrow-left"/><\/th><th colspan="5" class="switch"><\/th><th class="next"><i class="icon-arrow-right"/><\/th><\/tr><\/thead>',contTemplate:'<tbody><tr><td colspan="7"><\/td><\/tr><\/tbody>',footTemplate:'<tfoot><tr><th colspan="7" class="today"><\/th><\/tr><\/tfoot>'},t.template='<div class="datepicker"><div class="datepicker-days"><table class=" table-condensed">'+t.headTemplate+"<tbody><\/tbody>"+t.footTemplate+'<\/table><\/div><div class="datepicker-months"><table class="table-condensed">'+t.headTemplate+t.contTemplate+t.footTemplate+'<\/table><\/div><div class="datepicker-years"><table class="table-condensed">'+t.headTemplate+t.contTemplate+t.footTemplate+"<\/table><\/div><\/div>",n.fn.datepicker.DPGlobal=t}(window.jQuery);